<?php
/*
** USAGE:
**
** - Point your browser to "http://www.site.com/fsupdate.php" and follow
**   the instructions.
**
*/

if (!get_cfg_var("safe_mode")) {
  set_time_limit(180);
}

$mysql_updates = array(
  "4.00" => "update_1"
);

// Update functions
function update_1() {
  update_sql("ALTER TABLE filestore CHANGE nid nid int(10) unsigned DEFAULT '0' NOT NULL;");
  update_sql("ALTER TABLE filestore DROP lid;");
  update_sql("ALTER TABLE filestore ADD PRIMARY KEY (nid);");
  update_sql("ALTER TABLE filestore ADD filetype varchar(255) DEFAULT 'application/octet-stream' NOT NULL;");
  update_sql("ALTER TABLE filestore ADD filesize int(11) unsigned DEFAULT '0' NOT NULL;");
  update_sql("ALTER TABLE filestore ADD filename varchar(255) DEFAULT '' NOT NULL;");

  $result = db_query("SELECT nid,abstract,description,filedata FROM filestore");
  while ($object = db_fetch_object($result)) {
    db_query("UPDATE TABLE node SET teaser='%s', body='%s' WHERE nid='%s'", $object->abstract, $object->description, $object->nid);
    $filesize = strlen(base64_decode($object->filedata));
    db_query("UPDATE TABLE filestore SET filesize='%s' WHERE nid='%s'", $filesize, $object->nid);
  }
  update_sql("ALTER TABLE filestore DROP abstract;");
  update_sql("ALTER TABLE filestore DROP description;");

  $result = db_query("SELECT nid,title FROM node WHERE type = 'filestore'");
  while ($object = db_fetch_object($result)) {
    db_query("UPDATE TABLE filestore SET filename='%s' WHERE nid='%s'", $object->title, $object->nid);
  }

  update_sql("CREATE TABLE fstore_upload (
      upid int(10) unsigned DEFAULT '0' NOT NULL auto_increment,
      timestamp int(11) DEFAULT '0' NOT NULL,
      filedata mediumblob NOT NULL,
      filetype varchar(255) DEFAULT 'application/octet-stream' NOT NULL,
      filesize int(11) unsigned DEFAULT '0' NOT NULL,
      filename varchar(255) DEFAULT '' NOT NULL,
      PRIMARY KEY (upid),
      KEY timestamp (timestamp)
  );");
}


/*
** System functions
*/

function update_sql($sql) {
  global $edit;
  print nl2br(htmlentities($sql)) ." ";
  $result = db_query($sql);
  if ($result) {
    print "<font color=\"green\">OK</font>\n";
    return 1;
  }
  else {
    print "<font color=\"red\">FAILED</font>\n";
    if ($edit["bail"]) {
      die("Fatal error. Bailing");
    }
    return 0;
  }
}

function update_data($start) {
  global $mysql_updates;
  foreach ($mysql_updates as $vers => $func) {
    if ($vers > $start) {
      print "<b>$vers</b><br />\n<pre>\n";
      $func();
      variable_set("filestore_version", $vers);
      print "</pre>\n";
    }
  }
}

function update_page() {
  global $op, $edit, $user, $mysql_updates;

  $start = variable_get("filestore_version", "3.0");
  switch ($op) {
    case "Update":
      // make sure we have updates to run.
      print "<html><h1>Drupal update</h1>";
      print "<b>&raquo; <a href=\"index.php\">home</a></b><br />\n";
      print "<b>&raquo; <a href=\"index.php?q=admin\">administer</a></b><br />\n";
      foreach ($mysql_updates as $vers => $func) {
        // do nothing.
      }
      if (version_compare($vers, $start, "<=")) {
        print "No updates to perform.";
      }
      else {
        update_data($start);
      }
      print "</html>";
      break;
    default:

      // make update form and output it.
      $form .= form_select("Stop on errors", "bail", 0, array("Disabled", "Enabled"), "Don't forget to backup your database before performing an update.");
      $form .= form_submit("Update");
      print "<html><h1>Drupal update</h1>";
      print form($form);
      print "</html>";
      break;
  }
}

function update_info() {
  print "<html><h1>Drupal update</h1>";
  print "<h2>Instructions</h2>\n";
  print "<ol>\n";
  print "<li><p>Before doing anything backup your database. This process will change your database and its values, and some things might get lost.</p></li>\n";
  print "<li><p>Don't run this script twice as it will cause some serious problems!</p></li>\n";
  print "<li><p><b>Backup your database.</b> If you haven't done it by now don't blame anyone if by some statistical anomaly things blow up and you loose all data.</p></li>\n";
  print "<li><p>Remove or disable access to fsupdate.php so nobody else can tamper with the database.</p></li>\n";
  print "<li><p>Thanks for using the filestore module!</p></li>\n";
  print "</ol>";
  print "<p><b>&raquo; <a href=\"fsupdate.php?op=Upgrade\">Upgrade filestore tables.</a></b></p>\n";
  print "</html>";
}

// Security check:

if ($op) {
  include_once "includes/common.inc";
  if (user_access(NULL)) {
    update_page();
  }
  else {
    print message_access();
  }
}
else {
  update_info();
}
?>
